import wx
import wx.lib.hyperlink as hl

import time

WIDTH = 150
HEIGHT = 100
INTERVAL = 30
MARGIN_WIDTH = 10

class BalloonFrame(wx.MiniFrame):
    def __init__(self, parent, id):
        wx.Frame.__init__(self, parent, id, size=(WIDTH, HEIGHT), style=wx.FRAME_NO_TASKBAR)

        self.timer = wx.Timer(self)
        self.timer.Start(INTERVAL)
        dWidth, dHeight = wx.GetClientDisplayRect()[2:]
        self.Move((dWidth-WIDTH-MARGIN_WIDTH, dHeight))

        self.moved = 0
        self.Bind(wx.EVT_TIMER, self.OnTimerSlideIn)
        self.SetBackgroundColour((255,255,255))
        width, height = self.GetClientSize()
        #self.SetBackgroundColour((255, 255,255))


        self.bmp = wx.Image('images/balloon.png', wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        self.numOfReceived = 0

        #self.Bind(wx.EVT_PAINT, self.OnPaint)

    def AddResult(self, name, url, count):
        self.numOfReceived += 1
        width, height = self.GetSize()

        self.SetSize((width, height + 14))
        hl.HyperLinkCtrl(self, -1, '%s (%s)' % (name, count), pos=(0, 14*self.numOfReceived), size=(width, -1), URL=url)
        #wx.StaticText(self, -1, 'asd', pos=(0, 20), size=(width, -1), style=wx.ALIGN_CENTRE)


    def OnTimerSlideIn(self, event):
        x, y = self.GetPosition()
        y -= 1
        self.moved += 1
        self.Move((x, y))
        width, height = self.GetSize()
        if self.moved == height:
            self.timer.Stop()
            wx.Yield()
            time.sleep(1.5)
            self.Bind(wx.EVT_TIMER, self.OnTimerSlideOut)
            self.timer.Start(INTERVAL)

    def OnTimerSlideOut(self, event):
        x, y = self.GetPosition()
        y += 1
        self.moved -= 1
        self.Move((x, y))
        if self.moved == 0:
            self.timer.Stop()
            self.Destroy()

    def OnPaint(self, event):
        dc = wx.BufferedPaintDC(self)
        #dc.SetBackground(wx.BLACK_BRUSH)
        #dc.Clear()
        cw = self.bmp.GetWidth()
        ch = self.bmp.GetHeight()
        dc.DrawBitmap(self.bmp, 0, 0, True)

        #dc.DrawBitmap(self.bitmapFrame, 0, 0, True)

            
class MyApp(wx.App):
    def OnInit(self):
        frame = BalloonFrame(None, -1)
        frame.AddResult('name', 'http://jangc.net', '1')
        frame.Show(True)
        self.SetTopWindow(frame)
        return True

if __name__ == '__main__':
    try:
        app = MyApp(0)
        app.MainLoop()
    except Exception, msg:
        mDlg = wx.MessageDialog(None, str(msg), 'Error', wx.OK | wx.ICON_INFORMATION)
        mDlg.ShowModal()
        mDlg.Destroy()
