# -*- coding: utf8 -*-
import os
import glob
import sys
import cPickle
import poplib

import wx
import wx.lib.hyperlink as hl
import BalloonFrame


[   
    ID_FRAME1, ID_LISTCTRL, ID_NOTEBOOK, ID_ACCOUNT_MANAGE_PANEL, ID_TIMER
] = [wx.NewId() for _init_ctrls in range(5)]

import Checkers

checkerMap = {}
for module in filter(lambda name:name.endswith('Checker'), dir(Checkers)):
    checkerMap[module] = Checkers.__dict__[module]

checkerList = checkerMap.keys()
checkerList.sort()

class AboutPanel(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)
        wx.StaticText(self, -1, "Author : ", pos=(10, 30))
        self._hyper1 = hl.HyperLinkCtrl(self, -1, "Sung-hwan Jang", URL="http://jangc.net", pos=(60, 30))
        wx.StaticText(self, -1, "Homepage : ", pos=(10, 50))
        self._hyper2 = hl.HyperLinkCtrl(self, -1, "http://postman.kldp.net", URL="http://postman.kldp.net", pos=(80, 50))
        
        


class ConfigPanel(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)

        start = 10 
        step = 30

        wx.StaticText(self, -1, "Interval", pos=(10, start+5)) 
        #self.tc_interval = wx.TextCtrl(self, -1, pos=(80, start))
        self.interval = 10
        intervalList = map(str, [5, 10, 15, 20, 25, 30])
        self.cb_intervals = wx.ComboBox(self, -1, str(self.interval), (80, start), 
                         (60, -1), intervalList,
                         wx.CB_DROPDOWN
                         #| wx.TE_PROCESS_ENTER
                         | wx.CB_READONLY
                         #| wx.CB_SORT
                         )

        self.cb_balloon = wx.CheckBox(self, -1, "Balloon", pos=(160, start+5), style=wx.NO_BORDER)
        self.cb_balloon.SetValue(True)

        self.loadConfig()


    def loadConfig(self):
        try:
            L = cPickle.load(file('config.cfg', 'rb'))
            self.cb_intervals.SetValue(L[0])
            self.cb_balloon.SetValue(L[1])
        except Exception, msg:
            print 'load except :', str(msg)
            self.cb_intervals.SetValue("10")
            self.cb_balloon.SetValue(True)

    def saveConfig(self):
        print 'save'
        cPickle.dump( [
                    self.cb_intervals.GetValue(), 
                    self.cb_balloon.GetValue()
                ],
                file('config.cfg', 'wb')
        )

class AccountManagePanel(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)


        self.account_list = []
        self.lc_account_list = wx.ListCtrl(self, ID_LISTCTRL, pos=(10, 10), size=(300, 200), 
                                        style= wx.LC_REPORT  
                                                | wx.LC_HRULES
                                                | wx.LC_VRULES
                                        )

        self.lc_account_list.Bind(wx.EVT_KEY_DOWN, self.KeyDown)

        heads = [' ', 'Checker', 'ID']
        for i in range(len(heads)):
            self.lc_account_list.InsertColumn(i, heads[i])
        headWidths= [30, 150, 90]
        for i in range(len(heads)):
            self.lc_account_list.SetColumnWidth(i, headWidths[i])
        
        start = 220
        step = 30
        
        wx.StaticText(self, -1, "Checker", pos=(10, start))
        self.cb_checker = wx.ComboBox(self, -1, "", (80, start), 
                         (100, -1), checkerList,
                         wx.CB_DROPDOWN
                         #| wx.TE_PROCESS_ENTER
                         | wx.CB_READONLY
                         #| wx.CB_SORT
                         )
        wx.StaticText(self, -1, "ID", pos=(10, start + step))
        self.tc_uid = wx.TextCtrl(self, -1, pos=(80, start + step))

        wx.StaticText(self, -1, "Passwd", pos=(10, start + step * 2))
        self.tc_passwd = wx.TextCtrl(self, -1, pos=(80, start + step * 2), style=wx.TE_PASSWORD)

        b = wx.Button(self, -1, "Registration", pos=(200, start))
        b.SetDefault()
        b.Bind(wx.EVT_BUTTON, self.OnRegistration)

        c = wx.Button(self, -1, "Check now!", pos=(200, start + step * 2))
        c.Bind(wx.EVT_BUTTON, self.Check)
   
        self.loadAccounts()


    def loadAccounts(self):
        try: 
            self.account_list = cPickle.load(file('accounts'))
        except IOError:
            self.account_list = []
        for checkerName, uid, passwd in self.account_list:
            index = self.lc_account_list.GetItemCount()
            self.lc_account_list.InsertStringItem(index, '')
            self.lc_account_list.SetStringItem(index, 1, checkerName)
            self.lc_account_list.SetStringItem(index, 2, uid)
 
    def deleteSelectedAccounts(self):
        index = self.lc_account_list.GetFirstSelected()
        while index >= 0:
            self.lc_account_list.DeleteItem(index)
            self.account_list.pop(index)
            index = self.lc_account_list.GetFirstSelected()
        cPickle.dump(self.account_list, file('accounts', 'w'))

    def KeyDown(self, evt):
        key = evt.GetKeyCode()
        if key == 127: # delete
            self.deleteSelectedAccounts()

    def OnRegistration(self, evt):
        checkerName = self.cb_checker.GetValue().strip()
        uid = self.tc_uid.GetValue().strip()
        passwd = self.tc_passwd.GetValue().strip()
        if not (checkerName and uid and passwd):
            mDlg = wx.MessageDialog(None, 'fill the blank', 'Empty', wx.OK | wx.ICON_INFORMATION)
            mDlg.ShowModal()
            mDlg.Destroy()
            return
        index = self.lc_account_list.GetItemCount()
        self.lc_account_list.InsertStringItem(index, '')
        self.lc_account_list.SetStringItem(index, 1, checkerName)
        self.lc_account_list.SetStringItem(index, 2, uid)
        self.account_list.append((checkerName, uid, passwd))

        cPickle.dump(self.account_list, file('accounts', 'w'))

        # clear
        self.tc_uid.SetValue('')
        self.tc_passwd.SetValue('')

        
        '''
        import poplib
        mbox = poplib.POP3_SSL(self.tc_host.GetValue())
        mbox.user(self.tc_uid.GetValue())
        mbox.pass_(self.tc_passwd.GetValue())
        print mbox.stat()
        '''

    def Check(self, evt): # FIXME
        self.GetParent().GetParent().checkMailBox(evt)

class MyFrame(wx.Frame):    
    TBMENU_SHOW = wx.NewId()
    TBMENU_CLOSE = wx.NewId()
    def __init__(self, parent):
        # generated method, don't edit
        wx.Frame.__init__(self, id=ID_FRAME1, name='', parent=parent, 
                            pos=wx.Point(385, 320), size=wx.Size(335, 375), 
                            title='PyPostMan',
                            style=wx.MINIMIZE_BOX | wx.CLOSE_BOX | wx.CAPTION | wx.SYSTEM_MENU 
                         )
        #self.SetClientSize(wx.Size(387, 359))


        self.icon_normal = wx.Icon("images/postbox.png", wx.BITMAP_TYPE_PNG) 
        self.icon_new = wx.Icon("images/postbox_new.png", wx.BITMAP_TYPE_PNG) 
        self.icon_error = wx.Icon("images/postbox_error.png", wx.BITMAP_TYPE_PNG) 

        self.icon = self.icon_normal
        self.SetIcon(self.icon)
        self.tbicon = wx.TaskBarIcon() 

        self.notebook = wx.Notebook(self, ID_NOTEBOOK, size=self.GetClientSize(), style=wx.BK_DEFAULT)
        
        self.accountManagePanel = AccountManagePanel(self.notebook, ID_ACCOUNT_MANAGE_PANEL)
        self.notebook.AddPage(self.accountManagePanel, "Accounts")

        self.configPanel = ConfigPanel(self.notebook, -1)
        self.notebook.AddPage(self.configPanel, "General")


        self.aboutPanel = AboutPanel(self.notebook, -1)
        self.notebook.AddPage(self.aboutPanel, "About")

        self.balloon = self.configPanel.cb_balloon.GetValue()

        self.timer = wx.Timer(self, ID_TIMER)
        self.timer.Start(self.configPanel.interval * 60 * 1000)

        self.Bind(wx.EVT_TIMER, self.checkMailBox)
        self.configPanel.cb_intervals.Bind(wx.EVT_COMBOBOX, self.OnConfigChange)
        self.configPanel.cb_balloon.Bind(wx.EVT_CHECKBOX, self.OnConfigChange)
        wx.EVT_TASKBAR_LEFT_DCLICK(self.tbicon, self.OnTaskBarActivate) 
        wx.EVT_TASKBAR_LEFT_UP(self.tbicon, self.OnTaskBarActivate) 
        wx.EVT_TASKBAR_RIGHT_UP(self.tbicon, self.OnTaskBarMenu) 
        wx.EVT_MENU(self.tbicon, self.TBMENU_SHOW, self.OnTaskBarActivate) 
        wx.EVT_MENU(self.tbicon, self.TBMENU_CLOSE, self.OnTaskBarClose) 
        wx.EVT_CLOSE(self, self.OnWxFrameClose)

    def checkMailBox(self, event):
        total = 0
        try:
            bf = BalloonFrame.BalloonFrame(self, -1)
            for checkerName, uid, passwd in self.accountManagePanel.account_list:
                checker = checkerMap[checkerName]
                received = checker.check(uid, passwd)
                url = checker.getConfirmURL()
                bf.AddResult(checkerName, url, received)
                total += received
            if total > 0:
                if self.balloon:
                    bf.Show(True)
                self.icon = self.icon_new
            else:
                self.icon = self.icon_normal
            print total
        except Exception, msg:
            self.icon = self.icon_error
            print str(msg)
        if self.tbicon.IsIconInstalled():
            self.tbicon.SetIcon(self.icon, "PyPostman")

       #poplib.POP3_SSL(self.accountManagePanel.tc_host.GetValue())

    def OnConfigChange(self, event):
        # interval
        interval = int(self.configPanel.cb_intervals.GetValue())
        self.timer.Stop()
        self.timer.Start(interval * 60 * 1000)
        # balloon
        self.balloon = self.configPanel.cb_balloon.GetValue()
        self.configPanel.saveConfig()

    def OnWxFrameClose(self, evt): 
        self.tbicon.SetIcon(self.icon, "PyPostman") 
        self.Show(False) 
        #evt.Skip() 

    # TaskBarIcon handlers
    def OnTaskBarActivate(self, evt): 
        #if self.IsIconized(): 
        #    self.Iconize(false) 
        #if not self.IsShown(): 
        self.icon = self.icon_normal
        self.tbicon.RemoveIcon() 
        self.Show(True) 
        wx.GetApp().ProcessIdle() 
        #self.Raise() 

    def OnTaskBarMenu(self, evt): 
        menu = wx.Menu() 
        menu.Append(self.TBMENU_SHOW, "&Show") 
        menu.Append(self.TBMENU_CLOSE,   "&Close") 
        self.tbicon.PopupMenu(menu) 
        menu.Destroy() 
        wx.GetApp().ProcessIdle() 

    def OnTaskBarClose(self, evt): 
        self.Destroy() 
        wx.GetApp().ProcessIdle()# ????  



class MyApp(wx.App):
    def OnInit(self):
        frame = MyFrame(None)#, -1, "postman")   # parent, ID, title
        frame.Show(True)
        
        #self.SetIcon
        #frame.SetIcon(wx.Icon('./images/icon.ico', wx.BITMAP_TYPE_ICO))
        self.SetTopWindow(frame)
        return True

if __name__ == '__main__':
    try:
        app = MyApp(0)
        app.MainLoop()
    except Exception, msg:
        mDlg = wx.MessageDialog(None, str(msg), 'Error', wx.OK | wx.ICON_INFORMATION)
        mDlg.ShowModal()
        mDlg.Destroy()
